﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Security.Principal
Imports System.Web

<ComClass(CheckPermission.ClassId, CheckPermission.InterfaceId, CheckPermission.EventsId)> _
Public Class CheckPerm
    Implements IDisposable

#Region "API Region"
    'typedef struct _TRUSTEE {
    '  PTRUSTEE pMultipleTrustee;
    '  MULTIPLE_TRUSTEE_OPERATION MultipleTrusteeOperation;
    '  TRUSTEE_FORM TrusteeForm;
    '  TRUSTEE_TYPE TrusteeType;
    '  LPTSTR ptstrName;
    '} TRUSTEE, *PTRUSTEE;
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto, Pack:=4)> _
    Private Structure TRUSTEE
        Dim pMultipleTrustee As IntPtr
        Dim MultipleTrusteeOperation As Integer
        Dim TrusteeForm As Integer
        Dim TrusteeType As Integer
        Dim ptstrName As IntPtr
    End Structure

    'typedef enum _SE_OBJECT_TYPE {
    '  SE_UNKNOWN_OBJECT_TYPE = 0,
    '  SE_FILE_OBJECT,
    '  SE_SERVICE,
    '  SE_PRINTER,
    '  SE_REGISTRY_KEY,
    '  SE_LMSHARE,
    '  SE_KERNEL_OBJECT,
    '  SE_WINDOW_OBJECT,
    '  SE_DS_OBJECT,
    '  SE_DS_OBJECT_ALL,
    '  SE_PROVIDER_DEFINED_OBJECT,
    '  SE_WMIGUID_OBJECT,
    '  SE_REGISTRY_WOW64_32
    '} SE_OBJECT_TYPE;
    Private Enum SE_OBJECT_TYPE As Integer
        SE_UNKNOWN_OBJECT_TYPE = 0
        SE_FILE_OBJECT
        SE_SERVICE
        SE_PRINTER
        SE_REGISTRY_KEY
        SE_LMSHARE
        SE_KERNEL_OBJECT
        SE_WINDOW_OBJECT
        SE_DS_OBJECT
        SE_DS_OBJECT_ALL
        SE_PROVIDER_DEFINED_OBJECT
        SE_WMIGUID_OBJECT
        SE_REGISTRY_WOW64_32
    End Enum

    Private Enum SECURITY_INFORMATION As Integer
        OWNER_SECURITY_INFORMATION = 1
        GROUP_SECURITY_INFORMATION = 2
        DACL_SECURITY_INFORMATION = 4
        SACL_SECURITY_INFORMATION = 8
        PROTECTED_SACL_SECURITY_INFORMATION = 16
        PROTECTED_DACL_SECURITY_INFORMATION = 32
        UNPROTECTED_SACL_SECURITY_INFORMATION = 64
        UNPROTECTED_DACL_SECURITY_INFORMATION = 128
    End Enum

    'VOID BuildTrusteeWithSid(
    '  PTRUSTEE pTrustee,
    '  PSID pSid
    ');
    Private Declare Auto Sub BuildTrusteeWithSid Lib "advapi32.dll" ( _
        ByVal pTrustee As IntPtr, _
        ByVal pSid As IntPtr _
    )

    'DWORD GetNamedSecurityInfo(
    '  LPTSTR pObjectName,
    '  SE_OBJECT_TYPE ObjectType,
    '  SECURITY_INFORMATION SecurityInfo,
    '  PSID* ppsidOwner,
    '  PSID* ppsidGroup,
    '  PACL* ppDacl,
    '  PACL* ppSacl,
    '  PSECURITY_DESCRIPTOR* ppSecurityDescriptor
    ');
    Private Declare Auto Function GetNamedSecurityInfo Lib "advapi32.dll" ( _
        ByVal pObjectName As String, _
        ByVal ObjectType As SE_OBJECT_TYPE, _
        ByVal SecurityInfo As SECURITY_INFORMATION, _
        ByRef ppsidOwner As IntPtr, _
        ByRef ppsidGroup As IntPtr, _
        ByRef ppDacl As IntPtr, _
        ByRef ppSacl As IntPtr, _
        ByRef ppSecurityDescriptor As IntPtr _
    ) As Integer

    'DWORD GetEffectiveRightsFromAcl(
    '  PACL pacl,
    '  PTRUSTEE pTrustee,
    '  PACCESS_MASK pAccessRights
    ');
    Private Declare Auto Function GetEffectiveRightsFromAcl Lib "advapi32.dll" ( _
        ByVal pacl As IntPtr, _
        ByVal pTrustee As IntPtr, _
        ByRef pAccessRights As Integer _
    ) As Integer

    'BOOL LookupAccountName(
    '  LPCTSTR lpSystemName,
    '  LPCTSTR lpAccountName,
    '  PSID Sid,
    '  LPDWORD cbSid,
    '  LPTSTR ReferencedDomainName,
    '  LPDWORD cchReferencedDomainName,
    '  PSID_NAME_USE peUse
    ');
    Private Declare Auto Function LookupAccountName Lib "advapi32.dll" ( _
        ByVal lpSystemName As String, _
        ByVal lpAccountName As String, _
        ByVal Sid As IntPtr, _
        ByRef cbSid As Integer, _
        ByVal lpReferenceDomainName As String, _
        ByRef cchReferencedDomainName As Integer, _
        ByRef peUse As Integer _
    ) As Boolean

    Private Enum FileAccessType As Integer
        DELETE = &H10000
        READ_CONTROL = &H20000
        WRITE_DAC = &H40000
        WRITE_OWNER = &H80000
        SYNCHRONIZE = &H100000
        STANDARD_RIGHTS_REQUIRED = &HF0000
        STANDARD_RIGHTS_READ = READ_CONTROL
        STANDARD_RIGHTS_WRITE = READ_CONTROL
        STANDARD_RIGHTS_EXECUTE = READ_CONTROL
        STANDARD_RIGHTS_ALL = &H1F0000
        SPECIFIC_RIGHTS_ALL = &HFFFF
        ACCESS_SYSTEM_SECURITY = &H1000000
        MAXIMUM_ALLOWED = &H2000000
        'GENERIC_READ = &H80000000
        'GENERIC_WRITE = &H40000000
        'GENERIC_EXECUTE = &H20000000
        'GENERIC_ALL = &H10000000
        FILE_READ_DATA = &H1
        FILE_WRITE_DATA = &H2
        FILE_APPEND_DATA = &H4
        FILE_READ_EA = &H8
        FILE_WRITE_EA = &H10
        FILE_EXECUTE = &H20
        FILE_READ_ATTRIBUTES = &H80
        FILE_WRITE_ATTRIBUTES = &H100
        FILE_ALL_ACCESS = STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &H1FF
        FILE_GENERIC_READ = STANDARD_RIGHTS_READ Or FILE_READ_DATA Or FILE_READ_ATTRIBUTES Or FILE_READ_EA Or SYNCHRONIZE
        FILE_GENERIC_WRITE = STANDARD_RIGHTS_WRITE Or FILE_WRITE_DATA Or FILE_WRITE_ATTRIBUTES Or FILE_WRITE_EA Or FILE_APPEND_DATA Or SYNCHRONIZE
        FILE_GENERIC_EXECUTE = STANDARD_RIGHTS_EXECUTE Or FILE_READ_ATTRIBUTES Or FILE_EXECUTE Or SYNCHRONIZE
    End Enum

    Public Const ClassId As String = "abe27927-ebe3-4dff-9242-278a0ce70edd"
    Public Const InterfaceId As String = "7b195574-6615-4446-98d9-ed0d9c8885e3"
    Public Const EventsId As String = "5d183ec1-0792-4642-915f-990da43770ed"
#End Region

    Private pUserName As String
    Private pPath As String
    Private pMask As Integer
    Private pPermission As String
    Private pTrustee, pSID As IntPtr

    ' the default contstructor...
    Public Sub New()
        If IsNothing(System.Web.HttpContext.Current) Then
            pUserName = Environment.UserDomainName & "\" & Environment.UserName
        Else
            pUserName = System.Web.HttpContext.Current.Request.LogonUserIdentity.Name
        End If
        pPath = ""
        pMask = 1179785 ' Read
        pPermission = "Read"
        pTrustee = IntPtr.Zero
        pSID = IntPtr.Zero
    End Sub

    ' The name of the user that we will use to test the permissions
    Public Property UserName() As String
        Get
            Return pUserName
        End Get
        Set(ByVal value As String)
            pUserName = value
        End Set
    End Property

    ' The path to the file or directory to test
    Public Property Path() As String
        Get
            Return pPath
        End Get
        Set(ByVal value As String)
            pPath = value
        End Set
    End Property

    ' the "raw" access mask to test (not normally used... see Permissions)
    Public Property Mask() As Integer
        Get
            Return pMask
        End Get
        Set(ByVal value As Integer)
            pMask = value
        End Set
    End Property

    ' The string representation of the permission to test
    Public Property Permission() As String
        Get
            Return pPermission
        End Get
        Set(ByVal value As String)
            pPermission = value
        End Set
    End Property

    ' convert a string permission into a mask
    Private Function GetMask(ByVal Perm As String) As Integer
        Dim ans As Integer = -1

        ' translate the "common access types" into their numerical equivalents
        Select Case Perm
            Case "Full Control"
                ans = FileAccessType.FILE_ALL_ACCESS
            Case "Modify"
                ans = FileAccessType.FILE_ALL_ACCESS And Not (FileAccessType.WRITE_DAC Or FileAccessType.WRITE_OWNER Or &H40)
            Case "Read & Execute"
                ans = FileAccessType.FILE_GENERIC_READ Or FileAccessType.FILE_GENERIC_EXECUTE
            Case "Read"
                ans = FileAccessType.FILE_GENERIC_READ
            Case "Write"
                ans = FileAccessType.FILE_GENERIC_WRITE
            Case "Execute"
                ans = FileAccessType.FILE_GENERIC_EXECUTE
            Case Else
                Throw New ApplicationException("Permission type '" & Perm & "' is not supported")
        End Select

        Return ans
    End Function

    ' convert a string user name into a Trustee
    Private Function GetTrustee(ByVal User As String) As IntPtr
        Dim Domain As String
        Dim lenDomain, lenSid, peUse, LastError As Integer
        Dim ans As IntPtr

        ' do a "dry run" to get the size of the SID and Domain string
        LookupAccountName(Nothing, User, Nothing, lenSid, Nothing, lenDomain, peUse)
        Domain = Space(lenDomain)
        pSID = Marshal.AllocHGlobal(lenSid)

        ' do it again, for real this time
        If LookupAccountName(Nothing, User, pSID, lenSid, Domain, lenDomain, peUse) = False Then
            LastError = Marshal.GetLastWin32Error()
            Marshal.FreeHGlobal(pSID)
            Throw New ApplicationException("Can't generate SID for " & User, New Win32Exception(LastError))
        End If

        ' Build a trustee
        ans = Marshal.AllocHGlobal(Marshal.SizeOf(GetType(TRUSTEE)))
        BuildTrusteeWithSid(ans, pSID)

        Return ans
    End Function

    ' Perform the test... return true if the permission is granted
    Public Function CheckPerm(ByVal File_Path As String, ByVal User_Name As String, ByVal Access_Mask As Integer) As Boolean
        Dim DACL, SD As IntPtr
        Dim ret, Rights As Integer

        ' Some quick sanity checks...
        If [String].IsNullOrEmpty(File_Path) Then
            Throw New ApplicationException("Missing Path information")
        End If
        If [String].IsNullOrEmpty(User_Name) Then
            Throw New ApplicationException("Missing User information")
        End If
        If Access_Mask = 0 Then
            Throw New ApplicationException("Missing Mask information")
        End If

        ' Map to the physical path (if required)
        If Not IsNothing(System.Web.HttpContext.Current) Then
            File_Path = System.Web.HttpContext.Current.Request.MapPath(File_Path)
        End If

        ' convert User_Name into a Trusee
        pTrustee = GetTrustee(User_Name)

        ' Get the DACL from the file
        ret = GetNamedSecurityInfo(File_Path, SE_OBJECT_TYPE.SE_FILE_OBJECT, SECURITY_INFORMATION.DACL_SECURITY_INFORMATION, Nothing, Nothing, DACL, Nothing, SD)
        If ret <> 0 Then
            Throw New ApplicationException("Can't get security info from " & File_Path, New Win32Exception(ret))
        End If

        ' Get the Access Mask using the supplied user account
        ret = GetEffectiveRightsFromAcl(DACL, pTrustee, Rights)

        ' clean up
        Marshal.FreeHGlobal(SD)

        If ret <> 0 Then
            Throw New ApplicationException("Can't get effective rights from " & File_Path, New Win32Exception(ret))
        End If

        ' Let's see if we've got a match!
        If (Rights And Access_Mask) = Access_Mask Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Function CheckPerm(ByVal File_Path As String, ByVal User_Name As String, ByVal Access_Perm As String) As Boolean
        Return CheckPerm(File_Path, User_Name, GetMask(Access_Perm))
    End Function

    Public Function CheckPerm(ByVal File_Path As String, ByVal User_Name As String) As Boolean
        Return CheckPerm(File_Path, User_Name, pMask)
    End Function

    Public Function CheckPerm(ByVal FilePath As String) As Boolean
        Return CheckPerm(FilePath, pUserName, pMask)
    End Function

    Public Function CheckPerm() As Boolean
        Return CheckPerm(pPath, pUserName, pMask)
    End Function

    Public Overloads Sub Dispose() Implements IDisposable.Dispose
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

    Protected Overloads Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            ' nothing comes to mind...
        End If

        If pSID.ToInt32 <> 0 Then
            Marshal.FreeHGlobal(pSID)
        End If
        If pTrustee.ToInt32 <> 0 Then
            Marshal.FreeHGlobal(pTrustee)
        End If
    End Sub

    Protected Overrides Sub Finalize()
        Dispose(False)
    End Sub
End Class

